Subject: Re: bug#41982: [PATCH 0/1] gnu: grub: Cross-build fix for system i686-linux.

From: Ludovic Courtès <[email-masked]>
Date: Tue, 23 Jun 2020 17:54:43 +0200

Hi,

Jan Nieuwenhuizen <[email-masked]> skribis:

> Ludovic Courtès writes:
>
> Hello,
>
>> Jan Nieuwenhuizen <[email-masked]> skribis:
>>
>>> Attempting to reconfigure a i686-linux guix system to a Hurd system, I
>>> found that the Grub(-minimal) cross build fails like this
>>>
>>> i586-pc-gnu-gcc -DHAVE_CONFIG_H -I. -I..  -Wall -W
>>> -DGRUB_MACHINE_PCBIOS=1 -DGRUB_MACHINE=I386_PC -m32 -nostdinc
>>> -isystem
>>> /gnu/store/5s0ldm31100d9ix15d1lmbsvi0aa77pq-gcc-cross-i586-pc-gnu-7.5.0-lib/lib/gcc/i586-pc-gnu/7.5.0/include
>>> -I../include -I../include -DGRUB_FILE=\"lib/cmos_datetime.c\"
>
> [..]
>>> lib/.deps-core/datetime_module-cmos_datetime.Tpo -c -o
>>> lib/datetime_module-cmos_datetime.o `test -f 'lib/cmos_datetime.c'
>>> || echo './'`lib/cmos_datetime.c
>>> lib/i386/relocator64.S: Assembler messages:
>>> lib/i386/relocator64.S:66: Error: unknown pseudo-op: `.code64'
>>> lib/i386/relocator64.S:74: Error: bad register name `%rax'
>>> lib/i386/relocator64.S:98: Error: bad register name `%rax'
>>> lib/i386/relocator64.S:132: Error: bad register name `%rip)'
>>
>> Interesting.  Why doesn’t it happen when doing:
>>
>>   guix build grub-minimal -s i686-linux
>>
>> ?  That’s because ‘as’ supports ‘.code64’ there?
>
> Ah, that could be a switch!  I imagined ".code64" was not supported,
> "just like" using 64-bit registers.

Yeah I didn’t know about the existence of such a thing but the manual
has it (info "(as) i386-16bit").

> Pushed to master as cd6b0910dc471afb76677109625af0a42ce3056a

Cool, thanks!

Ludo’.